//
//  ViewController.m
//  Bzzzt
//
//  Created by Steve on 11/24/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "ViewController.h"

@implementation ViewController
@synthesize status;
@synthesize result;
@synthesize retryButton;

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle


- (void)viewDidLoad {
    
	UIAccelerometer *accel = [UIAccelerometer sharedAccelerometer];
	accel.delegate = self;
	accel.updateInterval = 1.0f/100.0f;
    zAxis = [[NSMutableArray alloc] init];
    xAxis = [[NSMutableArray alloc] init];
    dict = [[NSMutableDictionary alloc] init];
    before = 0;
    state = 2;
    flatXPeak = -1.0;
	flatPeak = 1.0;
    [super viewDidLoad];
}

- (void)viewDidUnload
{

    [self setRetryButton:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;

}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{

	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{

	[super viewDidDisappear:animated];

}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    //return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
    return NO;
}



- (void)accelerometer:(UIAccelerometer *)accelerometer
		didAccelerate:(UIAcceleration *)acceleration
{
    
                
    
    if(state < 2) {
        [zAxis addObject:[NSNumber numberWithDouble:acceleration.z]];
        [xAxis addObject:[NSNumber numberWithDouble:acceleration.x]];
        //NSLog(@"%f %f %f",acceleration.x, acceleration.y, acceleration.z);
    }

    
    if ([zAxis count] == 500 && state < 2) {
        [retryButton setEnabled:NO];
        if(state == 0) {
            // BERECHNUNG RUHE
            status.text = @"Calculating highest neutral peak...";
            double value = 0;
            NSNumber *zv;
            for (zv in zAxis) {
                value = value + [zv doubleValue];
                if([zv doubleValue] < flatPeak) {
                    flatPeak = [zv doubleValue];
                }
            }
            before = value / [zAxis count];
			
			NSLog(@"FLAT Z PEAK: %f",flatPeak);
			
            
            NSNumber *xv;
            for (xv in xAxis) {
                if([xv doubleValue] > flatXPeak) {
                    flatXPeak = [xv doubleValue];
                }
            }
            
            NSLog(@"FLAT X PEAK: %f",flatXPeak);
            		
            // RESET ARRAY
            zAxis = [[NSMutableArray alloc] init];
            xAxis = [[NSMutableArray alloc] init];
            // BEGINNE VIBRATION ASYNC
            status.text = @"Vibrating...";
            dispatch_async( dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
                // background processing
                for (int i=0; i<5; i++) {
                    //NSLog(@"VIBRATE");
                    AudioServicesPlaySystemSound (kSystemSoundID_Vibrate);
                    [NSThread sleepForTimeInterval:1.0];
                }  
                
                dispatch_async( dispatch_get_main_queue(), ^{
                    // update the UI/send notifications based on the
                    // results of the background processing
                });
            });
            state = 1;
        } else if(state == 1) {
            

            
            
            // BERECHNUNG NICHT RUHE
            status.text = @"Calculating surface peaks...";
			
			
          //  double value = 0;
           // double peak = 0;
			

            NSNumber *zv;
			
			/*
            for (zv in zAxis) {
                value = value + [zv doubleValue];
                if([zv doubleValue] < peak) {
                    peak = [zv doubleValue];
                }
            }
			 */
			
            int noOfPeaks = 0;
            for (zv in zAxis) {
				NSLog(@"peak: %f",[zv doubleValue]);
                 if([zv doubleValue] > flatPeak) {
               // if([zv doubleValue] > flatPeak*1.005) {
                    noOfPeaks++;
                }
            }
			 
            
            // x axis peaks
            int xPeaks = 0;
            NSNumber *xV;
            for(xV in xAxis) {
                if([xV doubleValue] > flatXPeak) {
                    xPeaks++;
                }
            }
			
			/*
            
            NSNumber *count = [dict objectForKey:[NSString stringWithFormat:@"%d", xPeaks]];
            if(count == nil) {
                NSNumber *countObj = [NSNumber numberWithInt:1];
                [dict setObject:countObj forKey: [NSString stringWithFormat:@"%d", xPeaks]];
            } else {
                int newCount = [count intValue] + 1;
                [dict setObject:[NSNumber numberWithInt:newCount] forKey: [NSString stringWithFormat:@"%d", xPeaks]];
            }
			 
			 */
            
			/*
            // threshold check
            int sum = 0;
            NSArray *keys = [dict allKeys];
            for (NSString *key in keys) {
                int val = [key intValue];
                if(xPeaks <= val+5 && xPeaks >= val-5) {
                    NSNumber *count = [dict objectForKey:key];
                    sum = sum + [count intValue];
                } else {
                }
            }                
            
            if (sum > 2) {
                result.text = @"Known surface!";
            } else {
                result.text = @"Unknown surface!";
            }
			*/ 
			
			NSString *data;
			if(noOfPeaks > 490) {
				result.text = @"Soft surface!";
				data = [NSString stringWithFormat: @"label:soft key:%d", noOfPeaks]; 
			} else {
				result.text = @"Hard surface!";
				data = [NSString stringWithFormat: @"label:hard key:%d", noOfPeaks]; 
			}
			
			status.text = [NSString stringWithFormat:@"Surface Key: %d; Threshold: %d", noOfPeaks, 490];
			
			 state = 2;
			
			// SEND HTTP POST REQUEST
			
			
			NSLog(@"Sending HTTP POST request.");
			
			NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:@"http://192.168.2.41/cgi-bin/ios.py"] 
																   cachePolicy:NSURLRequestReloadIgnoringLocalAndRemoteCacheData
															   timeoutInterval:1];
			
			NSData *requestData = [NSData dataWithBytes:[data UTF8String] length:[data length]];
			
			[request setHTTPMethod: @"POST"];
			[request setValue:@"application/json" forHTTPHeaderField:@"Accept"];
			[request setValue:@"application/json" forHTTPHeaderField:@"Content-Type"];
			[request setValue:[NSString stringWithFormat:@"%d", [requestData length]] forHTTPHeaderField:@"Content-Length"];
			[request setHTTPBody: requestData];
			
			
			NSURLConnection *connection = [[NSURLConnection alloc]
										   initWithRequest:request
										   delegate:self
										   startImmediately:YES];
			
			NSLog(@"HTTP POST sent.");
			

           
            zAxis = [[NSMutableArray alloc] init];
            [retryButton setTitle:@"Detect" forState:UIControlStateNormal];
            [retryButton setEnabled:YES];
        } else {
            status.text = @"Error!";
        }

    }

}

- (IBAction)retrySurfaceDetection: (id) sender
{
    status.text = [NSString stringWithFormat:@"Retry state: %d", state];
    [retryButton setEnabled:NO];
    [retryButton setTitle:@"..." forState:UIControlStateNormal];
    result.text = @"Working...";
    status.text = @"Silence, do not move...";
    state = 0;
	flatXPeak = -1.0;
	flatPeak = 1.0;
}

@end
